QGIS Application - Bug report #13741
Spatialite moving fields
2015-11-02 03:01 PM - Jakub Kosik

Status: Closed

Priority: High

Assignee:

Category: Data Provider/SpatialLite

Affected QGIS version:2.12.0

Operating System: Windows
Pull Request or Patch supplied:
Crashes QGIS or corruptsdata:

Regression?: No
Easy fix?: No
Resolution: not reproducable

Copied to github as #: 21768

Description

When using spatialite database I've found strange behaviour: sometime, with no rule, fields are saved incorrectly. This is old problem,

same on 2.8, maybe earlier.

This only happens when | use table with (autoincremented) primary key. In 2.8 there was workaround - use table without primary key, but

it is impossible in 2.12 (related to #13482).

In example you can find fields "move left" on first two elements. Left or right move, with no rule.

History

#1 - 2015-11-06 01:16 AM - Giovanni Manghi

- Crashes QGIS or corrupts data changed from No to Yes
- Category changed from Data Provider to Data Provider/SpatiaLite

- Status changed from Open to Feedback

Can you please specify the exact steps to replicate and/or attach a sample dataset?

thanks.

#2 - 2015-11-06 03:32 AM - Jakub Kosik

As | said, there is no rule. | cannot specify exact steps, but this only happens when | digitise a lot: most vertex edit, some reshape, split, add ring. Problem

show up only when | hit save button.

| am restricted to share all my database, but | attached main tables export ("GeometriaDzialki" and "Zdjecia", as | noticed on polygon and line layers).

https://www.dropbox.com/s/nzt483ditfvtoni/kontrola.rar?di=0

#3 - 2015-11-06 05:37 AM - Jakub Kosik

After some research: only new added features are broken, eg. from copy-paste or split. They are displayed properly until save.

#4 - 2015-11-06 06:43 AM - Giovanni Manghi

Jakub Kosik wrote:
https://www.dropbox.com/s/nzt483ditfvtoni/kontrola.rar?dl=0

After some research: only new added features are broken, eg. from copy-paste or split. They are displayed properly until save.

| tried to split over and over the line layer "Zdjecia" and after saves attributes tables always looks fine to me. Maybe a screencast would help understanding

how to replicate the issue.

#5 - 2015-11-06 07:02 AM - Jakub Kosik

It's almost impossible to replicate this issue, so there is no hope to screencast. Issue happens once in a hundred saves, but in 50 person team it happens
way too often :/

PS. Main table is "GeometriaDzialki". Strange is, as | wrote in beginning - without PrimaryKey problem does not exists.

#6 - 2015-11-07 11:07 AM - Giovanni Manghi

see also #13298, seems the same issue.

#7 - 2015-11-07 12:22 PM - Jakub Kosik

Not same at all - | got mess in fields of single object, not mixed with other objects. Also geometry looks unbroken (but in my project objects disappeared

due to attribute defined styles).

#8 - 2015-11-14 01:36 PM - Jakub Kosik

Here is some screencast - only moment of save edits. After split attributes are on places. On save - move feft (one feature saved correctly, one broken).
https://www.dropbox.com/s/0a0almedvcdkgxg/MOV _0260.mp47?dI=0

#9 - 2015-12-27 04:07 PM - Giovanni Manghi

Jakub Kosik wrote:

Not same at all - | got mess in fields of single object, not mixed with other objects. Also geometry looks unbroken (but in my project objects

disappeared due to attribute defined styles).

Yes, it seems the same issue. From the other ticket "When attributes are getting mixed with other objects, it is often the record above or below in the

(table)" that is what happens exactly in the screencast you posted here.

| tried again and again with the table "GeometriaDzialki" and | wasn't able to replicate.

Please test again on QGIS master and report back.

#10 - 2016-05-23 09:08 AM - Giovanni Manghi

- Status changed from Feedback to Closed
- Resolution set to not reproducable
https://www.dropbox.com/s/0a0almedvcdkqxg/MOV_0260.mp4?dl=0

closing for lack of feedback, please reopen if necessary.

#11 - 2016-06-29 05:27 AM - Jakub Kosik
- Status changed from Closed to Reopened
Problem still exists in 2.14.3
| changed simple data layer into editable spatialite view - same effect of moving fields.
#12 - 2016-10-31 07:22 PM - Gregor Sanders
- Target version set to Version 2.18
This problem can be replicated consistently with the following steps:
1. Create a non-geometry table in a spatialite database.

Note: Any table in the Layers Panel can be added easily to a spatialite db using the Offline Editing plugin

2. Begin adding records to the table and populate more fields in the second and subsequent records than in the first added record.

Note: It does not matter if the table already contains records

3. Save your edits and the following behaviour should be observed:

only those fields that are changed in the first added record will retain data in subsequent records.
a value entered in any field not edited in the first record will be moved to the first available field in subsequent records.

- if more fields are edited in subsequent records than are edited in the first added record, data entered in the additional fields will be lost on save.
Note, and perhaps this is a key to solving the bug: This behaviour is only reproduced when editing a non-geometry table in a spatialite database, not in a

regular sqlite database.

#13 - 2017-03-07 07:03 AM - Giovanni Manghi
- Status changed from Reopened to Closed

Using recent QGIS releases this (and similar) issues seems to have "gone", at least | cannot replicate them anymore.
Please give it a try on 2.18.4 (the next LTR), possibly in a clean environment (no 3rd party plugins) and if again something weird happens

please report here with detailed steps. Thanks!
